"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.reorderFields = void 0;
const graphql_compose_1 = require("graphql-compose");
function reorderFields(modelTC, order, DKey, commonFieldKeys) {
    if (order) {
        if (Array.isArray(order)) {
            modelTC.reorderFields(order);
        }
        else {
            const newOrder = [];
            if (modelTC instanceof graphql_compose_1.ObjectTypeComposer && commonFieldKeys) {
                newOrder.push(...commonFieldKeys);
                newOrder.filter((value) => value === '_id' || value === DKey);
                newOrder.unshift('_id', DKey);
            }
            else {
                if (modelTC.getField('_id')) {
                    newOrder.push('_id');
                }
                newOrder.push(DKey);
            }
            modelTC.reorderFields(newOrder);
        }
    }
    return modelTC;
}
exports.reorderFields = reorderFields;
//# sourceMappingURL=reorderFields.js.map